## lighttpd 1.4.69

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.0 FATAL_ERROR)

project(lighttpd VERSION 1.4.69 LANGUAGES C)

# use C11 with CMake >= 3.1
set(CMAKE_C_STANDARD 11)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake)

include(CTest)

enable_testing()

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README")
set(CPACK_PACKAGE_VENDOR "jan@kneschke.de")

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES "/\\\\.;~$;/_;build/;CMakeFiles/;CMakeCache;gz$;Makefile\\\\.;trace;Testing/;foo;autom4te;cmake_install;CPack;\\\\.pem;ltmain.sh;configure;libtool;/config\\\\.;missing;autogen.sh;install-sh;Dart;aclocal;log$;Makefile$")

include(CPack)

include(GNUInstallDirs)

add_subdirectory(src build)
add_subdirectory(doc)
add_subdirectory(tests)

=== meson_options.txt ===
option('with_brotli',
	type: 'feature',
	value: 'disabled',
	description: 'with brotli-support for mod_deflate [default: off]',
)
option('with_bzip',
	type: 'feature',
	value: 'disabled',
	description: 'with bzip2-support for mod_deflate [default: off]',
)
option('with_dbi',
	type: 'feature',
	value: 'disabled',
	description: 'with dbi-support for mod_auth mod_vhostdb_dbi [default: off]',
)
option('with_libdeflate',
	type: 'feature',
	value: 'disabled',
	description: 'with libdeflate-support for mod_deflate [default: off]',
)
option('with_fam',
	type: 'feature',
	value: 'disabled',
	description: 'fam/gamin for reducing number of stat() calls [default: off]',
)
option('with_gnutls',
	type: 'boolean',
	value: false,
	description: 'with GnuTLS-support [default: off]',
)
option('with_krb5',
	type: 'feature',
	value: 'disabled',
	description: 'with Kerberos5-support for mod_auth [default: off]',
)
option('with_ldap',
	type: 'feature',
	value: 'disabled',
	description: 'with LDAP-support for mod_auth mod_vhostdb_ldap [default: off]',
)
option('with_libev',
	type: 'feature',
	value: 'disabled',
	description: 'libev support for fdevent handlers [default: off]',
)
option('with_libunwind',
	type: 'feature',
	value: 'disabled',
	description: 'with libunwind to print backtraces in asserts [default: off]',
)
option('with_lua',
	type: 'boolean',
	value: false,
	description: 'with lua for mod_magnet [default: off]',
)
option('with_maxminddb',
	type: 'feature',
	value: 'disabled',
	description: 'with MaxMind GeoIP2-support mod_maxminddb [default: off]',
)
option('with_mbedtls',
	type: 'boolean',
	value: false,
	description: 'with mbedTLS-support [default: off]',
)
option('with_mysql',
	type: 'feature',
	value: 'disabled',
	description: 'with mysql-support for mod_vhostdb_mysql [default: off]',
)
option('with_nettle',
	type: 'boolean',
	value: false,
	description: 'with Nettle-support [default: off]',
)
option('with_nss',
	type: 'boolean',
	value: false,
	description: 'with NSS-crypto-support [default: off]',
)
option('with_openssl',
	type: 'boolean',
	value: false,
	description: 'with openssl-support [default: off]',
)
option('with_pam',
	type: 'feature',
	value: 'disabled',
	description: 'with PAM-support for mod_auth [default: off]',
)
option('with_pcre2',
	type: 'boolean',
	value: true,
	description: 'with regex support [default: on]',
)
option('with_pcre',
	type: 'combo',
	choices: ['auto','pcre2','pcre','disabled'],
	value: 'auto',
	description: 'with regex support [default: auto]',
)
option('with_pgsql',
	type: 'feature',
	value: 'disabled',
	description: 'with postgres-support for mod_vhostdb_pgsql [default: off]',
)
option('with_sasl',
	type: 'feature',
	value: 'disabled',
	description: 'with SASL support for mod_authn_sasl [default: off]',
)
#option('with_valgrind',
#	type: 'boolean',
#	value: false,
#	description: 'with internal support for valgrind [default: off]',
#)
option('with_webdav_locks',
	type: 'feature',
	value: 'disabled',
	description: 'locks in webdav [default: off]',
)
option('with_webdav_props',
	type: 'feature',
	value: 'disabled',
	description: 'with property-support for mod_webdav [default: off]',
)
option('with_wolfssl',
	type: 'boolean',
	value: false,
	description: 'with wolfSSL-support [default: off]',
)
option('with_xattr',
	type: 'boolean',
	value: false,
	description: 'with xattr-support for the stat-cache [default: off]',
)
option('with_xxhash',
	type: 'feature',
	value: 'disabled',
	description: 'with system-provided libxxhash [default: off]',
)
option('with_zlib',
	type: 'feature',
	value: 'enabled',
	description: 'with deflate-support for mod_deflate [default: on]',
)
option('with_zstd',
	type: 'feature',
	value: 'disabled',
	description: 'with zstd-support for mod_deflate [default: off]',
)

option('build_extra_warnings',
	type: 'boolean',
	value: false,
	description: 'extra warnings (only enabled with gcc/clang)',
)
option('warn_cflags',
	type: 'string',
	value: '-g -g2 -Wall -Wmissing-declarations -Wcast-align -Wsign-compare -Wnested-externs -Wpointer-arith -D_FORTIFY_SOURCE=2 -fstack-protector-strong --param=ssp-buffer-size=4 -Wformat -Werror=format-security',
	description: 'CFLAGS to use when build_extra_warnings is active',
)

option('build_static',
	type: 'boolean',
	value: false,
	description: 'build a static lighttpd with all modules added',
)

option('moduledir',
	type: 'string',
	value: 'lib/lighttpd',
	description: 'Location to install modules to (relative to prefix)',
)

option('lua_version',
	type: 'string',
	description: 'Look for a specific lua version',
)

=== src/CMakeLists.txt ===
include(CheckCSourceCompiles)
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckVariableExists)
include(CheckTypeSize)
include(CheckLibraryExists)
include(CMakeDetermineCCompiler)
find_package(PkgConfig)

include(LighttpdMacros)

add_definitions(-D_TIME_BITS=64 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES -D_DEFAULT_SOURCE)

# default to ON
set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE BOOL "Default value for ``POSITION_INDEPENDENT_CODE`` of targets.")

option(WITH_XATTR "with xattr-support for the stat-cache [default: off]")
option(WITH_MYSQL "with mysql-support for mod_vhostdb_mysql [default: off]")
option(WITH_PGSQL "with postgres-support for mod_vhostdb_pgsql [default: off]")
option(WITH_DBI "with dbi-support for mod_vhostdb_dbi [default: off]")
option(WITH_GNUTLS "with GnuTLS-support [default: off]")
option(WITH_MBEDTLS "with mbedTLS-support [default: off]")
option(WITH_NSS "with NSS-crypto-support [default: off]")
option(WITH_OPENSSL "with openssl-support [default: off]")
option(WITH_WOLFSSL "with wolfSSL-support [default: off]")
option(WITH_NETTLE "with Nettle-support [default: off]")
option(WITH_PCRE2 "with regex support [default: on]" ON)
option(WITH_PCRE "with regex support [default: off]")
option(WITH_WEBDAV_PROPS "with property-support for mod_webdav [default: off]")
option(WITH_WEBDAV_LOCKS "locks in webdav [default: off]")
option(WITH_BROTLI "with brotli-support for mod_deflate [default: off]")
option(WITH_BZIP "with bzip2-support for mod_deflate [default: off]")
option(WITH_ZLIB "with deflate-support for mod_deflate [default: on]" ON)
option(WITH_ZSTD "with zstd-support for mod_deflate [default: off]")
option(WITH_KRB5 "with Kerberos5-support for mod_auth [default: off]")
option(WITH_LDAP "with LDAP-support for mod_auth mod_vhostdb_ldap [default: off]")
option(WITH_PAM "with PAM-support for mod_auth [default: off]")
option(WITH_LUA "with lua for mod_magnet [default: off]")
option(WITH_LUA_VERSION "specify lua version for mod_magnet")
# option(WITH_VALGRIND "with internal support for valgrind [default: off]")
option(WITH_FAM "fam/gamin for reducing number of stat() calls [default: off]")
option(WITH_LIBDEFLATE "with libdeflate-support for mod_deflate [default: off]")
option(WITH_LIBEV "libev support for fdevent handlers [default: off]")
option(WITH_LIBUNWIND "with libunwind to print backtraces in asserts [default: off]")
option(WITH_MAXMINDDB "with MaxMind GeoIP2-support mod_maxminddb [default: off]")
option(WITH_SASL "with SASL-support for mod_authn_sasl [default: off]")
option(WITH_XXHASH "with system-provided xxhash [default: off]")

if(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
	option(BUILD_EXTRA_WARNINGS "extra warnings")
	option(BUILD_SANITIZE_ADDRESS "Enable address sanitizer" OFF)
	option(BUILD_SANITIZE_UNDEFINED "Enable undefined sanitizer" OFF)

	if(BUILD_EXTRA_WARNINGS)
		set(WARN_CFLAGS "-g -g2 -Wall -Wmissing-declarations -Wcast-align -Wsign-compare -Wnested-externs -Wpointer-arith -D_FORTIFY_SOURCE=2 -fstack-protector-strong --param=ssp-buffer-size=4 -Wformat -Werror=format-security")
		set(WARN_LDFLAGS "")
		# -Werror -Wbad-function-cast -Wmissing-prototypes
		if(NOT BUILD_SANITIZE_ADDRESS)
			# with asan we need to link all libraries we might need later
			# so asan can initialize intercepts properly
			# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=103930
			set(WARN_LDFLAGS "${WARN_LDFLAGS} -Wl,--as-needed")
		endif()
	endif()

	set(SANITIZE_FLAGS "")

	if(BUILD_SANITIZE_ADDRESS)
		set(SANITIZE_FLAGS "${SANITIZE_FLAGS} -fsanitize=address")
	endif()

	if(BUILD_SANITIZE_UNDEFINED)
		set(SANITIZE_FLAGS "${SANITIZE_FLAGS} -fsanitize=undefined")
	endif()

	if(SANITIZE_FLAGS)
		set(WARN_CFLAGS "${SANITIZE_FLAGS} -fno-omit-frame-pointer ${WARN_CFLAGS}")
	endif()
endif()

option(BUILD_STATIC "build a static lighttpd with all modules added")

if(BUILD_STATIC)
	set(LIGHTTPD_STATIC 1)
elseif(APPLE)
	set(CMAKE_SHARED_MODULE_PREFIX "")
else()
	set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif()

if(WITH_LIBUNWIND)
	pkg_check_modules(LIBUNWIND REQUIRED libunwind)
	set(HAVE_LIBUNWIND 1)
endif()

if(WITH_WEBDAV_PROPS)
	set(WITH_XML 1)
	set(WITH_SQLITE3 1)
endif()

if(WITH_WEBDAV_LOCKS)
	set(WITH_UUID 1)
endif()

check_include_files(sys/inotify.h HAVE_SYS_INOTIFY_H)
set(CMAKE_REQUIRED_FLAGS "-include sys/time.h")
check_include_files(sys/loadavg.h HAVE_SYS_LOADAVG_H)
set(CMAKE_REQUIRED_FLAGS)
check_include_files(sys/poll.h HAVE_SYS_POLL_H)
check_include_files(sys/prctl.h HAVE_SYS_PRCTL_H)
check_include_files(sys/procctl.h HAVE_SYS_PROCCTL_H)
check_include_files(sys/sendfile.h HAVE_SYS_SENDFILE_H)
check_include_files(sys/un.h HAVE_SYS_UN_H)
check_include_files(sys/wait.h HAVE_SYS_WAIT_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(getopt.h HAVE_GETOPT_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(poll.h HAVE_POLL_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(syslog.h HAVE_SYSLOG_H)

# will be needed for auth
check_include_files(crypt.h HAVE_CRYPT_H)
# check if we need libcrypt for crypt_r()
check_library_exists(crypt crypt_r "" HAVE_LIBCRYPT_CRYPT_R)
if(HAVE_LIBCRYPT_CRYPT_R)
	set(HAVE_CRYPT_R 1)
	set(HAVE_LIBCRYPT 1)
else()
	check_library_exists(crypt crypt "" HAVE_LIBCRYPT_CRYPT)
	if(HAVE_LIBCRYPT_CRYPT)
		set(HAVE_CRYPT 1)
		set(HAVE_LIBCRYPT 1)
	endif()
endif()
check_function_exists(crypt_r HAVE_CRYPT_R)
check_function_exists(crypt HAVE_CRYPT)

set(CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
check_type_size(socklen_t HAVE_SOCKLEN_T)
set(CMAKE_EXTRA_INCLUDE_FILES)

check_include_files(malloc.h HAVE_MALLOC_H)
if(HAVE_MALLOC_H)
check_function_exists(malloc_trim HAVE_MALLOC_TRIM)
check_function_exists(mallopt HAVE_MALLOPT)
endif()

check_include_files(signal.h HAVE_SIGNAL_H)
if(HAVE_SIGNAL_H)
check_function_exists(sigaction HAVE_SIGACTION)
check_function_exists(signal HAVE_SIGNAL)
endif()

check_include_files(sys/epoll.h HAVE_SYS_EPOLL_H)
if(HAVE_SYS_EPOLL_H)
check_function_exists(epoll_ctl HAVE_EPOLL_CTL)
endif()

set(CMAKE_REQUIRED_FLAGS "-include sys/types.h")
check_include_files(sys/event.h HAVE_SYS_EVENT_H)
set(CMAKE_REQUIRED_FLAGS)
if(HAVE_SYS_EVENT_H)
check_function_exists(kqueue HAVE_KQUEUE)
endif()

check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
if(HAVE_SYS_MMAN_H)
check_function_exists(mmap HAVE_MMAP)
endif()

check_include_files(sys/random.h HAVE_SYS_RANDOM_H)
if(HAVE_SYS_RANDOM_H)
set(CMAKE_EXTRA_INCLUDE_FILES sys/random.h)
check_function_exists(getentropy HAVE_GETENTROPY)
set(CMAKE_EXTRA_INCLUDE_FILES)
endif()

check_include_files(linux/random.h HAVE_LINUX_RANDOM_H)
if(HAVE_LINUX_RANDOM_H)
set(CMAKE_EXTRA_INCLUDE_FILES linux/random.h)
check_function_exists(getrandom HAVE_GETRANDOM)
set(CMAKE_EXTRA_INCLUDE_FILES)
endif()

check_include_files(sys/resource.h HAVE_SYS_RESOURCE_H)
if(HAVE_SYS_RESOURCE_H)
check_function_exists(getrlimit HAVE_GETRLIMIT)
endif()

check_include_files(sys/uio.h HAVE_SYS_UIO_H)
if(HAVE_SYS_UIO_H)
check_function_exists(preadv HAVE_PREADV)
check_function_exists(pwritev HAVE_PWRITEV)
check_function_exists(writev HAVE_WRITEV)
endif()

check_function_exists(poll HAVE_POLL)
if(NOT HAVE_POLL)
check_include_files(sys/select.h HAVE_SYS_SELECT_H)
check_function_exists(select HAVE_SELECT)
endif()

set(CMAKE_EXTRA_INCLUDE_FILES time.h)
check_function_exists(timegm HAVE_TIMEGM)
set(CMAKE_EXTRA_INCLUDE_FILES)

if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
check_include_files(port.h HAVE_PORT_H)
check_include_files(priv.h HAVE_PRIV_H)
check_include_files(sys/devpoll.h HAVE_SYS_DEVPOLL_H)
check_include_files(sys/filio.h HAVE_SYS_FILIO_H)
check_function_exists(port_create HAVE_PORT_CREATE)
check_function_exists(sendfilev HAVE_SENDFILEV)
check_function_exists(setpflags HAVE_SETPFLAGS)
endif()

check_type_size(long SIZEOF_LONG)
check_type_size(off_t SIZEOF_OFF_T)

check_function_exists(arc4random_buf HAVE_ARC4RANDOM_BUF)
check_function_exists(chroot HAVE_CHROOT)
check_function_exists(copy_file_range HAVE_COPY_FILE_RANGE)
check_function_exists(fork HAVE_FORK)
check_function_exists(getloadavg HAVE_GETLOADAVG)
check_function_exists(getuid HAVE_GETUID)
check_function_exists(gmtime_r HAVE_GMTIME_R)
check_function_exists(jrand48 HAVE_JRAND48)
check_function_exists(localtime_r HAVE_LOCALTIME_R)
check_function_exists(lstat HAVE_LSTAT)
check_function_exists(madvise HAVE_MADVISE)
check_function_exists(mempcpy HAVE_MEMPCPY)
check_function_exists(mkostemp HAVE_MKOSTEMP)
check_function_exists(pipe2 HAVE_PIPE2)
check_function_exists(pread HAVE_PREAD)
check_function_exists(pwrite HAVE_PWRITE)
check_function_exists(sendfile HAVE_SENDFILE)
check_function_exists(sendfile64 HAVE_SENDFILE64)
check_function_exists(splice HAVE_SPLICE)
check_function_exists(srandom HAVE_SRANDOM)
check_function_exists(strerror_r HAVE_STRERROR_R)
check_function_exists(issetugid HAVE_ISSETUGID)
check_function_exists(memset_s HAVE_MEMSET_S)
check_function_exists(explicit_bzero HAVE_EXPLICIT_BZERO)
check_function_exists(explicit_memset HAVE_EXPLICIT_MEMSET)
check_symbol_exists(clock_gettime "time.h" HAVE_CLOCK_GETTIME)
if (NOT HAVE_CLOCK_GETTIME)
	check_library_exists(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME)
endif()
check_library_exists(elftc elftc_copyfile "libelftc.h" HAVE_ELFTC_COPYFILE)
if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
set(CMAKE_REQUIRED_LIBRARIES "socket;nsl")
elseif(CMAKE_SYSTEM_NAME MATCHES "Haiku")
set(CMAKE_REQUIRED_LIBRARIES "network")
elseif(WIN32)
set(CMAKE_REQUIRED_LIBRARIES "ws2_32")
endif()
check_function_exists(inet_aton HAVE_INET_ATON)
check_function_exists(inet_pton HAVE_INET_PTON)
check_c_source_compiles("
	#include <sys/types.h>
	#include <sys/socket.h>
	#include <netinet/in.h>

	int main() {
		struct sockaddr_in6 s; struct in6_addr t=in6addr_any; int i=AF_INET6; s; t.s6_addr[0] = 0;
		return 0;
	}" HAVE_IPV6)
if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
set(CMAKE_REQUIRED_LIBRARIES)
endif()
check_c_source_compiles("
	__attribute__((weak)) void __dummy(void *x) { }
	int main() {
		void *x;
		__dummy(x);
	}
	" HAVE_WEAK_SYMBOLS)
check_c_source_compiles("
	#include <time.h>
	int main(void) {
		struct tm t;
		t.tm_gmtoff = 0;
		return 0;
	}
	" HAVE_STRUCT_TM_GMTOFF)

## refactor me
macro(XCONFIG _package _link_FLAGS _cflags)
# reset the variables at the beginning
	set(${_link_FLAGS})
	set(${_cflags})

	find_program(${_package}CONFIG_EXECUTABLE NAMES ${_package})

	# if pkg-config has been found
	if(${_package}CONFIG_EXECUTABLE)
		set(XCONFIG_EXECUTABLE "${${_package}CONFIG_EXECUTABLE}")
		message(STATUS "found ${_package}: ${XCONFIG_EXECUTABLE}")

		if(${_package} STREQUAL "pcre2-config")
			exec_program(${XCONFIG_EXECUTABLE} ARGS --libs8 OUTPUT_VARIABLE __link_FLAGS)
		else()
			exec_program(${XCONFIG_EXECUTABLE} ARGS --libs OUTPUT_VARIABLE __link_FLAGS)
		endif()
		string(REPLACE "\n" "" ${_link_FLAGS} ${__link_FLAGS})
		exec_program(${XCONFIG_EXECUTABLE} ARGS --cflags OUTPUT_VARIABLE __cflags)
		string(REPLACE "\n" "" ${_cflags} ${__cflags})
	else()
		message(STATUS "found ${_package}: no")
	endif()
endmacro()

if(WITH_XATTR)
	check_include_files("sys/types.h;sys/xattr.h" HAVE_SYS_XATTR_H)
	check_function_exists(getxattr HAVE_XATTR)
	check_include_files("sys/types.h;sys/extattr.h" HAVE_SYS_EXTATTR_H)
	check_function_exists(extattr_get_file HAVE_EXTATTR)
	if(NOT HAVE_XATTR AND NOT HAVE_EXTATTR)
		check_include_files("sys/types.h;attr/attributes.h" HAVE_ATTR_ATTRIBUTES_H)
		if(HAVE_ATTR_ATTRIBUTES_H)
			check_library_exists(attr attr_get "" HAVE_XATTR)
		endif()
	endif()
else()
	unset(HAVE_ATTR_ATTRIBUTES_H)
	unset(HAVE_XATTR)
endif()

if(WITH_MYSQL)
	xconfig(mysql_config MYSQL_LDFLAGS MYSQL_CFLAGS)
	if(MYSQL_LDFLAGS)
		set(HAVE_MYSQL TRUE)
	endif()
else()
	unset(HAVE_MYSQL)
endif()

if(WITH_PGSQL)
	if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.14)

=== debian/changelog ===
lighttpd (1.4.69-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/index.html:
      + Corrected BTS Ubuntu link and branding on the default page.
    - debian/lighttpd.dirs, debian/control, debian/rules,
      debian/lighttpd.ufw.profile:
      + Add the UFW profile.
    + Make the application build sanely:
      - Install updated upstream NEWS file and fix
        cp: cannot stat /debian/tmp/changelog thingy to
        fix FTBFS when built twice in a row.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 02 May 2023 12:34:31 +0200

lighttpd (1.4.69-1) unstable; urgency=medium

  * New upstream version 1.4.69
  * Remove deprecated lighttpd modules.
  * Skip installing modules now built into lighttpd.
  * Add to not-installed mods now built into lighttpd.
  * Declare compliance with policy 4.6.2 - no changes needed.
  * lighttpd.init reopen-logs only if lighttpd is currently running.

 -- Glenn Strauss <gstrauss@gluelogic.com>  Fri, 10 Feb 2023 22:34:51 -0500

lighttpd (1.4.67-1ubuntu2) lunar; urgency=medium

  * No-change rebuild against libldap-2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 15 Dec 2022 19:51:04 +0000

=== debian/control ===
Source: lighttpd
Section: httpd
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian lighttpd maintainers <team+lighttpd@tracker.debian.org>
Uploaders: Glenn Strauss <gstrauss@gluelogic.com>, Stefan Bühler <stbuehler@web.de>
Homepage: https://www.lighttpd.net/
Build-Depends:
 dpkg-dev (>= 1.16.1~),
 debhelper-compat (= 12),
 libdeflate-dev,
 media-types <!nocheck> | mime-support <!nocheck>,
 libgnutls28-dev (>= 3.6.5),
 libmbedtls-dev (>= 2.14.0),
 libnss3-dev (>= 2:3.26.2),
 libssl-dev,
 libwolfssl-dev (>= 3.14.0~),
 zlib1g-dev,
 libbrotli-dev,
 libpcre2-dev,
 default-libmysqlclient-dev | libmysqlclient-dev,
 libdbi-dev,
 libldap2-dev,
 liblua5.4-dev,
 libmaxminddb-dev,
 pkg-config,
 uuid-dev,
 libsqlite3-dev,
 libxml2-dev,
 libkrb5-dev,
 libpam0g-dev,
 libpq-dev,
 libsasl2-dev,
 libunwind8-dev <pkg.lighttpd.libunwind>,
 libxxhash-dev,
 libzstd-dev,
 nettle-dev,
 perl:native,
Vcs-Git: https://salsa.debian.org/debian/lighttpd.git
Vcs-Browser: https://salsa.debian.org/debian/lighttpd
Standards-Version: 4.6.2
Rules-Requires-Root: binary-targets

Package: lighttpd
Architecture: any
Provides:
 httpd,
 httpd-cgi,
 ${lighttpd:ModuleProvides},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 media-types | mime-support,
 systemd-sysv | lsb-base,
Pre-Depends:
 ${misc:Pre-Depends},
Conflicts:
 lighttpd-mod-geoip,
 lighttpd-mod-trigger-b4-dl,
Recommends:
 spawn-fcgi,
 perl:any,
 lighttpd-mod-deflate,
 lighttpd-mod-openssl,
Suggests:
 openssl,
 php-cgi,
 php-fpm (>= 2:7.4),
 apache2-utils,
 lighttpd-doc,
 lighttpd-mod-webdav,
 lighttpd-modules-dbi,
 lighttpd-modules-lua,
 ufw
Description: fast webserver with minimal memory footprint
 lighttpd is a small webserver and fast webserver developed with
 security in mind and a lot of features.
 It has support for
   * CGI, FastCGI and SSI
   * virtual hosts
   * URL rewriting
   * authentication (plain files, htpasswd, LDAP)
   * transparent content compression
   * conditional configuration
   * HTTP proxying
 and configuration is straight-forward and easy.

Package: lighttpd-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 lighttpd,
Description: documentation for lighttpd
 lighttpd is a small webserver and fast webserver developed with
 security in mind and a lot of features.
 .
 This package contains documentation for lighttpd.

Package: lighttpd-modules-dbi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks:
 lighttpd-mod-vhostdb-dbi (<< 1.4.56~rc7-0+exp2),
Replaces:
 lighttpd (<< 1.4.56~rc7-0+exp2),
 lighttpd-mod-vhostdb-dbi (<< 1.4.56~rc7-0+exp2),
Provides:
 ${lighttpd:ModuleProvides},
Description: DBI-based modules for lighttpd
 This package contains the following modules:
  * mod_authn_dbi: DBI-based authentication
    mod_authn_dbi performs authentication against a database server
    via DBI interface.
  * mod_vhostdb_dbi: DBI-based virtual host configuration
    mod_vhostdb_dbi enables writing the configuration for virtual hosts
    into a database table instead of including it in the lighttpd
    configuration file.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-modules-ldap
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Provides:
 ${lighttpd:ModuleProvides},
Description: LDAP-based modules for lighttpd
 This package contains the following modules:
  * mod_authn_ldap: With this module, it is possible to perform
    authentication against an LDAP server.
  * mod_vhostdb_ldap: Database backend module for using LDAP as
    a source for virtual host configuration using mod_vhostdb.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-modules-lua
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Conflicts:
 lighttpd-mod-cml,
Breaks:
 lighttpd-mod-magnet (<< 1.4.56~rc7-0+exp2),
Replaces:
 lighttpd (<< 1.4.56~rc7-0+exp2),
 lighttpd-mod-magnet (<< 1.4.56~rc7-0+exp2),
Provides:
 ${lighttpd:ModuleProvides},
Description: LUA-based modules for lighttpd
 This package contains the following modules:
  * mod_magnet: control the request handling module for lighttpd
    mod_magnet can attract a request in several stages in the request-handling.
    either at the same level as mod_rewrite, before any parsing of the URL is
    done or at a later stage, when the doc-root is known and the physical-path
    is already setup.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-modules-mysql
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Conflicts:
 lighttpd-mod-authn-mysql,
 lighttpd-mod-mysql-vhost,
Provides:
 ${lighttpd:ModuleProvides},
Description: MySQL-based modules for lighttpd
 This package contains the following modules:
  * mod_vhostdb_mysql: Database backend module for using MySQL as
    a source for virtual host configuration using mod_vhostdb.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-mod-webdav
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: WebDAV module for lighttpd
 The WebDAV module is an implementation of RFC 4918.
 .
 Currently supports:
  GET
  POST
  HEAD
  PROPFIND
  PROPPATCH
  OPTIONS
  MKCOL
  COPY
  MOVE
  DELETE
  PUT
  LOCK
  UNLOCK

Package: lighttpd-mod-authn-gssapi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: GSSAPI authentication module for lighttpd
 This package contains the authn_gssapi module for lighttpd. With
 this module, it is possible to perform GSSAPI authentication.

Package: lighttpd-mod-authn-pam
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: PAM authentication module for lighttpd
 This package contains the authn_pam module for lighttpd. With this module, it
 is possible to perform authentication using PAM.

Package: lighttpd-mod-authn-sasl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: SASL authentication module for lighttpd
 This package contains the authn_sasl module for lighttpd. With this module, it
 is possible to perform authentication using SASL.

Package: lighttpd-mod-deflate
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks: lighttpd (<< 1.4.56~rc7-0+exp2)
Replaces: lighttpd (<< 1.4.56~rc7-0+exp2)
Description: HTTP response compression module for lighttpd
 This package contains the deflate module for lighttpd. With this module, it is
 possible compress HTTP responses using zlib, brotli, or zstd if supported by
 the client.

Package: lighttpd-mod-maxminddb
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: GeoIP2 info module for lighttpd
 This package contains the maxminddb module for lighttpd. With
 this module, it is possible to distinguish users based on the location
 using a GeoIP2 database.

Package: lighttpd-mod-vhostdb-pgsql
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: PostgreSQL-based virtual host configuration module for lighttpd
 This package contains the vhostdb_pgsql module for lighttpd. With this module,
 it is possible to write the configuration for virtual hosts into a PostgreSQL
 table instead of including it in the lighttpd configuration file.

Package: lighttpd-mod-gnutls
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: TLS support using GnuTLS module for lighttpd
 This package contains the gnutls module for lighttpd. With this module,
 it is possible serve https:// URLs.  GnuTLS is an alternative to OpenSSL.

Package: lighttpd-mod-mbedtls
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: TLS support using mbedTLS module for lighttpd
 This package contains the mbedtls module for lighttpd. With this module,
 it is possible serve https:// URLs.  Aimed at embedded systems, mbedTLS
 uses less memory than OpenSSL, though is slightly slower than OpenSSL.

Package: lighttpd-mod-nss
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: TLS support using NSS crypto module for lighttpd
 This package contains the nss module for lighttpd. With this module,
 it is possible serve https:// URLs.  NSS is an alternative to OpenSSL.

Package: lighttpd-mod-openssl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks: lighttpd (<< 1.4.56~rc7-0+exp2)
Replaces: lighttpd (<< 1.4.56~rc7-0+exp2)
Description: TLS support using OpenSSL module for lighttpd
 This package contains the openssl module for lighttpd. With this module, it is
 possible serve https:// URLs.

Package: lighttpd-mod-wolfssl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: TLS support using wolfSSL module for lighttpd
 This package contains the wolfssl module for lighttpd. With this module,
 it is possible serve https:// URLs.  Aimed at embedded systems, wolfSSL
 uses less memory than OpenSSL, though is slightly slower than OpenSSL.

=== debian/tests/control ===
Tests: defconfig
Depends: lighttpd, media-types
Restrictions: needs-root

Tests: load-all-modules
Depends: lighttpd, lighttpd-modules-ldap, lighttpd-modules-lua, lighttpd-modules-mysql, lighttpd-mod-webdav, lighttpd-mod-authn-gssapi, lighttpd-mod-authn-pam, lighttpd-mod-authn-sasl, lighttpd-mod-deflate, lighttpd-mod-maxminddb, lighttpd-modules-dbi, lighttpd-mod-vhostdb-pgsql

Tests: serve-static-file
Depends: lighttpd, curl
Restrictions: allow-stderr

Tests: serve-cgi-file
Depends: lighttpd
Restrictions: allow-stderr

Tests: do-not-emit-http-proxy-to-cgi
Depends: lighttpd
Restrictions: allow-stderr

Tests: integration-tests
Depends: lighttpd, lighttpd-mod-deflate, perl, gcc, libc-dev
Restrictions: allow-stderr, skip-not-installable

## lighttpd 1.4.73

=== debian/changelog ===
lighttpd (1.4.73-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/index.html:
      + Corrected BTS Ubuntu link and branding on the default page.
    - debian/lighttpd.dirs, debian/control, debian/rules,
      debian/lighttpd.ufw.profile:
      + Add the UFW profile.
    + Make the application build sanely:
      - Install updated upstream NEWS file and fix
        cp: cannot stat /debian/tmp/changelog thingy to
        fix FTBFS when built twice in a row.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 Nov 2023 15:30:25 +0100

lighttpd (1.4.73-1) unstable; urgency=medium
  * New upstream version 1.4.73

 -- Glenn Strauss <gstrauss@gluelogic.com>  Sat, 30 Oct 2023 02:00:00 -0400

lighttpd (1.4.72-1) unstable; urgency=medium
  * New upstream version 1.4.72 (closes: #1037337, #1040525)

 -- Glenn Strauss <gstrauss@gluelogic.com>  Sat, 07 Oct 2023 03:56:59 -0400

lighttpd (1.4.71-2) unstable; urgency=medium
  [ Glenn Strauss ]
  * Build under UTF-8
  * Address lintian pedantry
  * Drop NEWS relevant to o-o-stable
  * lighttpd.conf comments and simplifications

  [ Alexandre Detiste ]
  * simplify crontab find syntax + systemd hardening

 -- Glenn Strauss <gstrauss@gluelogic.com>  Sun, 10 Sep 2023 05:55:55 -0500

lighttpd (1.4.71-1+exp1) experimental; urgency=medium
  * New upstream version 1.4.71

 -- Glenn Strauss <gstrauss@gluelogic.com>  Sat, 03 Jun 2023 23:46:22 -0500

lighttpd (1.4.70-1+exp1) experimental; urgency=medium
  * New upstream version 1.4.70
  * Install new module mod_h2 (separated out from lighttpd executable)
  * Update debian/copyright for lighttpd 1.4.70
  * lighttpd.conf: move use-ipv6.pl after include conf-enabled/*.conf
    (closes: #1035926)

 -- Glenn Strauss <gstrauss@gluelogic.com>  Sat, 13 May 2023 03:11:33 -0500

lighttpd (1.4.69-1ubuntu2) noble; urgency=medium

  * Rebuild against new libwolfssl41.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Nov 2023 16:35:41 +0100

=== debian/rules ===
#!/usr/bin/make -f

# build under UTF-8
LC_ALL := C.UTF-8
export LC_ALL

# enable verbose mode
export DH_VERBOSE=1

# enable all hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# non-executable stack
export DEB_CFLAGS_MAINT_APPEND=-Wa,--noexecstack
export DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,noexecstack

%:
	dh $@

override_dh_clean:
	dh_clean
	find . -name Makefile.in -delete

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-dependency-tracking \
		--libdir=/usr/lib/lighttpd \
		--libexecdir="/usr/lib/lighttpd" \
		--with-attr \
		--with-brotli \
		--with-dbi \
		--with-gnutls \
		--with-krb5 \
		--with-ldap \
		--with-libdeflate \
		--with-lua=lua5.4 \
		--with-maxminddb \
		--with-mbedtls \
		--with-mysql \
		--with-nettle \
		--with-nss \
		--with-openssl \
		--with-pam \
		--with-pcre2 \
		--with-pgsql \
		--with-sasl \
		--with-webdav-locks \
		--with-webdav-props \
		--with-wolfssl \
		--with-xxhash \
		--with-zstd \
		$(if $(filter pkg.lighttpd.libunwind,$(DEB_BUILD_PROFILES)),--with-libunwind) \
		CFLAGS_FOR_BUILD="$(shell dpkg-buildflags --get CFLAGS)" \
		LDFLAGS_FOR_BUILD="$(shell dpkg-buildflags --get LDFLAGS)" \
		CPPFLAGS_FOR_BUILD="$(shell dpkg-buildflags --get CPPFLAGS)" \

override_dh_install:
	dh_install
	install -m644 debian/lighttpd.ufw.profile debian/lighttpd/etc/ufw/applications.d/lighttpd

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdocs:
	dh_installdocs -Nlighttpd -Nlighttpd-doc --link-doc=lighttpd
	dh_installdocs -plighttpd -plighttpd-doc

override_dh_fixperms-arch:
	dh_fixperms
	chmod 0750 debian/lighttpd/var/log/lighttpd
	chown www-data:www-data \
			debian/lighttpd/var/cache/lighttpd \
			debian/lighttpd/var/cache/lighttpd/compress \
			debian/lighttpd/var/cache/lighttpd/uploads \
			debian/lighttpd/var/log/lighttpd

override_dh_installinit:
	dh_installinit --error-handler=start_failed

override_dh_gencontrol:
	set -e; for p in `dh_listpackages`; do \
		test -d debian/$$p/usr/lib/lighttpd || continue; \
		m=`ls debian/$$p/usr/lib/lighttpd | sed 'y/_/-/;s/^mod-\(.*\)\.so$$/lighttpd-mod-\1,/;ta;d;:a /^'"$$p"',$$/d;' | xargs`; \
		echo "lighttpd:ModuleProvides=$$m" >> debian/$$p.substvars; \
	done
	dh_gencontrol
